# Use jbossdemocentral/developer as the base
FROM jbossdemocentral/developer:jdk8-uid

# Maintainer details
MAINTAINER Andrew Block, Eric D. Schabell, Duncan Doylle, Jaen Swart


RUN curl "http://rhel-repositorio.semperti.local/npersia/jboss/eap/patch/jboss-eap-6.4.7-patch.zip" >> /opt/jboss/jboss-eap-6.4.7-patch.zip

RUN curl "http://rhel-repositorio.semperti.local/npersia/jboss/eap/installer/jboss-eap-6.4.0-installer.jar" >> /opt/jboss/jboss-eap-6.4.0-installer.jar

RUN curl "http://rhel-repositorio.semperti.local/npersia/jboss/brms/installer/jboss-brms-6.3.0.GA-installer.jar" >> /opt/jboss/jboss-brms-6.3.0.GA-installer.jar


#RUN curl "http://rhel-repositorio.semperti.local/ws-brms/installs/jboss-brms-6.3.0.GA-installer.jar" >> /opt/jboss/jboss-brms-6.3.0.GA-installer.jar

#RUN curl "http://rhel-repositorio.semperti.local/ws-brms/installs/jboss-eap-6.4.0-installer.jar" >> /opt/jboss/jboss-eap-6.4.0-installer.jar

#RUN curl "http://rhel-repositorio.semperti.local/ws-brms/installs/jboss-eap-6.4.7-patch.zip" >> /opt/jboss/jboss-eap-6.4.7-patch.zip

# Environment Variables
ENV BRMS_HOME /opt/jboss/brms/jboss-eap-6.4
ENV BRMS_VERSION_MAJOR 6
ENV BRMS_VERSION_MINOR 3
ENV BRMS_VERSION_MICRO 0
ENV BRMS_VERSION_PATCH GA

ENV EAP_VERSION_MAJOR 6
ENV EAP_VERSION_MINOR 4
ENV EAP_VERSION_MICRO 0
ENV EAP_VERSION_PATCH 7

# ADD Installation Files
COPY support/installation-brms support/installation-eap support/installation-brms.variables support/installation-eap.variables /opt/jboss/

# Update Permissions on Installers
USER root
RUN chown 1000:1000 /opt/jboss/jboss-eap-$EAP_VERSION_MAJOR.$EAP_VERSION_MINOR.$EAP_VERSION_MICRO-installer.jar /opt/jboss/jboss-brms-$BRMS_VERSION_MAJOR.$BRMS_VERSION_MINOR.$BRMS_VERSION_MICRO.$BRMS_VERSION_PATCH-installer.jar
USER 1000

# Prepare and run installer and cleanup installation components
RUN sed -i "s:<installpath>.*</installpath>:<installpath>$BRMS_HOME</installpath>:" /opt/jboss/installation-eap \
    && sed -i "s:<installpath>.*</installpath>:<installpath>$BRMS_HOME</installpath>:" /opt/jboss/installation-brms \
	&& java -jar /opt/jboss/jboss-eap-$EAP_VERSION_MAJOR.$EAP_VERSION_MINOR.$EAP_VERSION_MICRO-installer.jar  /opt/jboss/installation-eap -variablefile /opt/jboss/installation-eap.variables \
    && $BRMS_HOME/bin/jboss-cli.sh --command="patch apply /opt/jboss/jboss-eap-$EAP_VERSION_MAJOR.$EAP_VERSION_MINOR.$EAP_VERSION_PATCH-patch.zip --override-all" \
    && java -jar /opt/jboss/jboss-brms-$BRMS_VERSION_MAJOR.$BRMS_VERSION_MINOR.$BRMS_VERSION_MICRO.$BRMS_VERSION_PATCH-installer.jar  /opt/jboss/installation-brms -variablefile /opt/jboss/installation-brms.variables \
    && rm -rf /opt/jboss/jboss-brms-$BRMS_VERSION_MAJOR.$BRMS_VERSION_MINOR.$BRMS_VERSION_MICRO.$BRMS_VERSION_PATCH-installer.jar /opt/jboss/jboss-eap-$EAP_VERSION_MAJOR.$EAP_VERSION_MINOR.$EAP_VERSION_MICRO-installer.jar /opt/jboss/jboss-eap-$EAP_VERSION_MAJOR.$EAP_VERSION_MINOR.$EAP_VERSION_PATCH-patch.zip /opt/jboss/installation-brms /opt/jboss/installation-brms.variables /opt/jboss/installation-eap /opt/jboss/installation-eap.variables $BRMS_HOME/standalone/configuration/standalone_xml_history/

# Copy demo and support files
COPY support/brms-demo-niogit $BRMS_HOME/bin/.niogit
COPY projects /opt/jboss/brms-projects
COPY support/libs /opt/jboss/brms-projects/libs
COPY support/userinfo.properties $BRMS_HOME/standalone/deployments/business-central.war/WEB-INF/classes/
COPY support/application-roles.properties support/standalone.xml $BRMS_HOME/standalone/configuration/
# Need to switch to root user to be able to set correct ownership on 'application-roles.properties' so we can add additional users using the JBoss 'add-user' script.
USER root
RUN chown 1000:1000 $BRMS_HOME/standalone/configuration/application-roles.properties 
USER 1000
# Create an additional user.
RUN $BRMS_HOME/bin/add-user.sh -a -r ApplicationRealm -u brmsAdmin -p jbossbrms1! -ro analyst,admin,manager,user,kie-server,rest-all --silent

#a ver si esto soluciona el problema del log
USER root
RUN chown 1000:1000 -R $BRMS_HOME/standalone/log/
RUN chmod o+rw -R $BRMS_HOME/standalone/log
RUN chmod o+rw -R $BRMS_HOME/standalone/data/content
USER 1000


# Switch back to root user to perform build and cleanup
USER root

# Run Demo Maven build and cleanup
RUN mvn install:install-file -Dfile=/opt/jboss/brms-projects/libs/coolstore-2.0.0.jar -DgroupId=com.redhat -DartifactId=coolstore -Dversion=2.0.0 -Dpackaging=jar \
  && mvn clean install -f /opt/jboss/brms-projects/brms-coolstore-demo/pom.xml \
  && cp /opt/jboss/brms-projects/brms-coolstore-demo/target/brms-coolstore-demo.war $BRMS_HOME/standalone/deployments/ \
  && chown -R jboss:jboss $BRMS_HOME/bin/.niogit $BRMS_HOME/standalone/configuration/application-roles.properties $BRMS_HOME/standalone/configuration/standalone.xml $BRMS_HOME/standalone/deployments/brms-coolstore-demo.war $BRMS_HOME/standalone/deployments/business-central.war/WEB-INF/classes/userinfo.properties \
  && rm -rf ~/.m2/repository /opt/jboss/brms-projects

RUN chmod o+rwX -R $BRMS_HOME

# Run as JBoss
USER 1000

# Expose Ports
EXPOSE 9990 9999 8080

# Run BRMS
CMD ["/opt/jboss/brms/jboss-eap-6.4/bin/standalone.sh","-c","standalone.xml","-b", "0.0.0.0","-bmanagement","0.0.0.0"]
